// TestMp402Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestMp402.h"
#include "TestMp402Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#pragma comment(lib,"MP402.lib")

#include "MP402.h"

HANDLE hDevice=INVALID_HANDLE_VALUE;

long Data[16];	//

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMp402Dlg dialog

CTestMp402Dlg::CTestMp402Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMp402Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestMp402Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestMp402Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestMp402Dlg)
	DDX_Control(pDX, IDC_LIST, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestMp402Dlg, CDialog)
	//{{AFX_MSG_MAP(CTestMp402Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_DI, OnButtonDi)
	ON_BN_CLICKED(IDC_BUTTON_AD, OnButtonAd)
	ON_BN_CLICKED(IDC_BUTTON_ADS, OnButtonAds)
	ON_BN_CLICKED(IDC_BUTTON_StopAD, OnBUTTONStopAD)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMp402Dlg message handlers

BOOL CTestMp402Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	GetDlgItem(IDC_BUTTON_StopAD)->EnableWindow(FALSE);
    state=0;

	m_List.InsertColumn( 0, "ͨ", LVCFMT_CENTER, 52, -1 );
	m_List.InsertColumn( 1, "ֵ", LVCFMT_CENTER, 65, -1 );
	m_List.InsertColumn( 2, "ѹֵ(V)", LVCFMT_CENTER, 72, -1 );

	//бʾͨ
	for(int i=0; i<=15; i++)
	{
		CString aa;
		aa.Format("  %d",i);
		m_List.InsertItem(i,aa);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestMp402Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMp402Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMp402Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CTestMp402Dlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	hDevice=MP402_OpenDevice(0);
	
	
	if(hDevice==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("error open MP402 Device!");
		Beep(1000,300);
		exit(0);
	}
	
	return 0;
}

void CTestMp402Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	
	MP402_DO(hDevice, 0x55aa);
	
}

void CTestMp402Dlg::OnButtonDi() 
{
	// TODO: Add your control notification handler code here
	CString data, IO_IN;
	long DIData;

	//IO
	DIData=MP402_DI(hDevice);

	//IOתΪʮݣ0x00xfffʾ
	IO_IN.Format("0x%x",DIData);
	GetDlgItem(IDC_EDIT_DI)->SetWindowText(IO_IN);
	
}

void CTestMp402Dlg::OnButtonAd() 
{
	// TODO: Add your control notification handler code here
	
	state=1;

	GetDlgItem(IDC_BUTTON_StopAD)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_ADS)->EnableWindow(FALSE);

	MP402_CAL(hDevice);
	SetTimer(1, 100, NULL);//ʱAD



	
}

void CTestMp402Dlg::OnButtonAds() 
{
	// TODO: Add your control notification handler code here
	state=2;
	
	GetDlgItem(IDC_BUTTON_StopAD)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_AD)->EnableWindow(FALSE);
	
	MP402_CAL(hDevice);
	SetTimer(2, 100, NULL);//ʱAD

	
}

void CTestMp402Dlg::OnBUTTONStopAD() 
{
	// TODO: Add your control notification handler code here
	if(state==1)
	{
		KillTimer(1);//ʱ
		GetDlgItem(IDC_BUTTON_ADS)->EnableWindow(TRUE);
	}

	if(state==2)
	{
		KillTimer(2);//ʱ
		GetDlgItem(IDC_BUTTON_AD)->EnableWindow(TRUE);
	}

	
}

void CTestMp402Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);

	char Buff1[16][100];//ֵ
	char Buff2[16][100];//ѹֵ

	if(nIDEvent==1)
	{
		long data;
		for(int i=0;i<16;i++)
		{
			data=MP402_AD(hDevice,i,2,0,10);//-5-+5V
			
			//data=data>>4;
			
			sprintf(Buff2[i], "%d", data);//תֵͨ
			
			sprintf(Buff1[i], "%6.3fV", (data-2048) * 5.0 / 2048);//ֵͨתΪѹֵ
			
			//бؼʾADֵѹֵ
			m_List.SetItemText(i, 1, Buff2[i]);
			m_List.SetItemText(i, 2, Buff1[i]);
		}

	}

	if(nIDEvent==2)
	{
		long data[16];
		
		MP402_ADScan(hDevice,0,15,3,0,data);//-10-+10V

		for(int i=0;i<16;i++)
		{
			//data[i]=data[i]>>4;

			sprintf(Buff2[i], "%d", data[i]);//תֵͨ
			
			sprintf(Buff1[i], "%6.3fV", (data[i]-2048) * 10.0 / 2048);//ֵͨתΪѹֵ
			
			//бؼʾADֵѹֵ
			m_List.SetItemText(i, 1, Buff2[i]);
			m_List.SetItemText(i, 2, Buff1[i]);
		}
		
		
	}
}
